;------------------------------------------------------
; SOLAR assembler
; Copyright (c) 2004,2018 Bogdan Valentin Ontanu,
; All rights reserved.
;------------------------------------------------------

.use64

;------------------------------------------------------------------
; This file is used to test Sol_ASM
; win64 DLL generation
;------------------------------------------------------------------


from kernel32.dll
	import		ExitProcess
	import		GetModuleHandle	alias GetModuleHandleA

from user32.dll
	import		MessageBox alias MessageBoxA
	
	
;---------------
; sections
;---------------
section 	"code" 		class_code
section 	"data" 		class_data
section 	"idata"		class_imports
section		"reloc"		class_relocs
section 	"edata" 	class_exports

.data
	msg_app_name		db	" Sol_Asm 64 bits DLL Test ",0
	msg_on_load		db	" DLL ON_LOAD ",0
	msg_on_unload		db	" DLL ON_UNLOAD ",0
	
.code


.entry  dll_main

start:
	sub	rsp,8
	nop
	
proc dll_main win64
	ARG	a_hinstance, a_reason, a_rezerved
	
	; spill is needed
	mov	[a_hinstance],rcx
	mov	[a_reason],rdx
	mov	[a_rezerved],r8
	
	mov	rax,[a_reason]
	
	.if rax == DLL_PROCESS_ATTACH
		invoke	MessageBox,0,msg_on_load,msg_app_name,MB_OK
		
	.elseif rax == 	DLL_PROCESS_DETACH
		invoke	MessageBox,0,msg_on_unload,msg_app_name,MB_OK
		
	.endif
	
	; return OK
	mov	rax,1
	ret
endp


.data
	msg_api_01	db	"Api_01 Called",0
	msg_api_02	db	"Api_02 Called",0
	msg_api_03	db	"Api_03 Called",0
	
.code


PROC api_01 win64
	uses	rsi,rdi
	arg	arg_1, arg_2
	
	invoke	MessageBox,0,msg_api_01,msg_app_name,MB_OK

	xor	eax,eax
	ret
ENDP


PROC api_02 win64
	uses	rsi,rdi

	invoke	MessageBox,0,msg_api_02,msg_app_name,MB_OK

	xor	eax,eax
	ret
ENDP


PROC api_03 win64
	uses	rsi,rdi

	invoke	MessageBox,0,msg_api_03,msg_app_name,MB_OK

	xor	eax,eax
	ret
ENDP


EXPORT api_01
EXPORT api_02
EXPORT api_03


include "..\win64_equ.asm"
include "..\win64_stru.asm"

